/**
 * Storage.js - a simple storage helper inspired by the redis api.
 *
 * @author     Artur Heinze
 * @copyright  (c) since 2012 Artur Heinze
 * @license    MIT - http://opensource.org/licenses/MIT
 * @url        https://github.com/aheinze/Storage.js
 */
(function(f){function d(a,b){var c=this;this.name=a;this.adapter=b;this.data=b.load(a);this.expires={};setInterval(function(){var a=(new Date).getTime(),b;for(b in c.expires)c.expires[b]<a&&(delete c.data[b],delete c.expires[b])},6E4)}d.prototype.store=function(a){this.adapter.store(this.name,this.data)};d.prototype.toString=function(a){return JSON.stringify(this.data)};d.prototype.flushdb=function(){var a=this;this.data={};this.expires={};setTimeout(function(){a.store()},0);return!0};d.prototype.get=
function(a,b){return void 0!==this.data[a]?this.data[a]:b};d.prototype.set=function(a,b){this.data[a]=b;this.store()};d.prototype.setex=function(a,b,c){this.set(a,c);this.expire(a,b)};d.prototype.expire=function(a,b){this.data[a]&&(this.expires[a]=(new Date).getTime()+1E3*b)};d.prototype.exists=function(a){return"___no___"!==this.get(a,"___no___")};d.prototype.del=function(){for(var a=arguments,b=null,c=0,d=0;d<a.length;d++)b=a[d],this.exists(b)&&(delete this.data[b],this.expires[b]&&delete this.expires[b],
c++);this.store();return c};d.prototype.type=function(a){a=this.get(a);return"object"===typeof a?"["===JSON.stringify(a)[0]?"list":"set":typeof a};d.prototype.append=function(a,b){b=String(b);var c=String(this.get(a,""))+b;this.set(a,c);return c.length};d.prototype.incr=function(a,b){b=b||1;var c=Number(this.get(a,0))+b;this.set(a,c);return c};d.prototype.decr=function(a,b){return this.incr(a,-1*(b||1))};d.prototype.llen=function(a){return this.get(a,[]).length};d.prototype.lpush=function(a,b){var c=
this.get(a,[]),d=c.unshift(b);this.set(a,c);return d};d.prototype.rpush=function(a,b){var c=this.get(a,[]),d=c.push(b);this.set(a,c);return d};d.prototype.lset=function(a,b,c){var d=this.get(a,[]);0>b&&(b=d.length-Math.abs(b));return d[b]?(d[b]=c,this.set(a,d),!0):!1};d.prototype.lindex=function(a,b){var c=this.get(a,[]);0>b&&(b=c.length-Math.abs(b));return c[b]?c[b]:null};d.prototype.hset=function(a,b,c){var d=this.get(a,{});d[b]=c;this.set(a,d)};d.prototype.hget=function(a,b,c){a=this.get(a,{});
return void 0!==a[b]?a[b]:c};d.prototype.hgetall=function(a){return this.get(a,{})};d.prototype.hexists=function(a,b){return void 0!==this.get(a,{})[b]};d.prototype.hkeys=function(a){a=this.get(a,{});var b=[],c=null;for(c in a)a.hasOwnProperty(c)&&b.push(c);return b};d.prototype.hvals=function(a){a=this.get(a,{});var b=[],c=null;for(c in a)a.hasOwnProperty(c)&&b.push(keys[c]);return b};d.prototype.hlen=function(a){return this.hkeys(a).length};d.prototype.hdel=function(a){if(!this.exists(a))return 0;
for(var b=this.get(a,{}),c=null,d=0,e=1;e<arguments.length;e++)c=arguments[e],void 0!==b[c]&&(delete b[c],d++);this.set(a,b);return d};d.prototype.hincrby=function(a,b,c){c=c||1;c=Number(this.hget(a,b,0))+c;this.hset(a,b,c);return c};d.prototype.hmget=function(a){for(var b=this.get(a,{}),c=null,d=[],e=1;e<arguments.length;e++)c=arguments[e],d.push(void 0!==b[c]?b[c]:null);return d};d.prototype.hmset=function(a){for(var b=this.get(a,{}),c=null,d=null,e=1;e<arguments.length;e++)c=arguments[e],d=arguments[e+
1]?arguments[e+1]:null,b[c]=d,e+=1;this.set(a,b)};var g={select:function(a,b){return new d(a,this.adapters[b]||this.adapters.memory)},adapters:{memory:function(){var a={};return{load:function(b){return a[b]||{}},store:function(b,c){a[b]=c}}}(),local:{load:function(a){return f.localStorage["storage."+a]?JSON.parse(f.localStorage["storage."+a]):{}},store:function(a,b){f.localStorage["storage."+a]=JSON.stringify(b)}},session:{load:function(a){return f.sessionStorage["storage."+a]?JSON.parse(f.sessionStorage["storage."+
a]):{}},store:function(a,b){f.sessionStorage["storage."+a]=JSON.stringify(b)}}}};"function"===typeof define&&define.amd?define(function(){return g}):"undefined"!==typeof exports?("undefined"!=typeof module&&module.exports&&(exports=module.exports=g),exports.Storage=g):window.Storage=g})(this);